package com.mtgg.controller;

import com.alibaba.fastjson.JSONObject;
import com.jfinal.weixin.sdk.api.SnsAccessToken;
import com.jfinal.weixin.sdk.api.SnsAccessTokenApi;
import com.mtgg.bean.ConfigBean;
import com.mtgg.common.ErrorCode;
import com.mtgg.common.Response;
import com.mtgg.utils.HttpUtils;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpEntity;
import org.springframework.http.HttpHeaders;
import org.springframework.http.HttpMethod;
import org.springframework.http.MediaType;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.client.RestTemplate;

import java.util.HashMap;
import java.util.Map;

@Slf4j
@RestController
@RequestMapping("/oauth")
public class OauthController {

    @Autowired
    private ConfigBean configBean;
    @Autowired
    private RestTemplate restTemplate;
    @Autowired
    private HttpUtils httpUtils;


    /**
     * @Author: MTGG
     * @Date: 9:33 2018/7/5
     * @Describe: 获取code
     */
    @RequestMapping(value = "/openid", method = RequestMethod.GET)
    public Response getCode(String code) {
        Response result = new Response();
        String appId = configBean.getWxAppId();
        String secret = configBean.getWxSecret();
        log.info("参数code：{}；appid：{}；secret：{}", code, appId, secret);
        //通过code换取网页授权access_token
        try {
            SnsAccessToken snsAccessToken = SnsAccessTokenApi.getSnsAccessToken(appId, secret, code);
            log.info("通过code换取网页授权access_token：{}", snsAccessToken);
            log.info("openid：{}", snsAccessToken.getOpenid());
            result.setObj(snsAccessToken);
            result.setRes(ErrorCode.SUCCESS.code);
            return result;
        } catch (Exception e) {
            log.info("错误");
            return null;
        }
    }

    @RequestMapping(value = "/send", method = RequestMethod.GET)
    public Response getDataByCityName(String cityName) {
        Response result = new Response();
//        String uri="http://wthrcdn.etouch.cn/weather_mini?city="+cityName;
        String uri = "http://www.baidu.com";
        HttpHeaders headers = new HttpHeaders();
        headers.setContentType(MediaType.APPLICATION_JSON_UTF8);
        HttpEntity<String> entity = new HttpEntity<String>(headers);
        String strbody = restTemplate.exchange(uri, HttpMethod.GET, entity, String.class).getBody();
        log.info("strbody:{}", strbody);
        JSONObject jsonObject = JSONObject.parseObject(strbody);
        log.info("json:{}", jsonObject);

        try {
            jsonObject = httpUtils.sendGet(uri);
            log.info("jsonObject:{}", jsonObject);
        } catch (Exception e) {
            e.printStackTrace();
            log.info("eeee:" + e);
        }
        result.setObj(jsonObject);
        return result;
    }


}
