package com.mtgg.service.imp;

import com.mtgg.dao.BaseMapper;
import com.mtgg.dao.BatisMapper;
import com.mtgg.dto.MtRecordDTO;
import com.mtgg.entity.MtRecordPO;
import com.mtgg.service.BatisService;
import com.mtgg.utils.PageDataDTO;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

@Transactional
@Service
public class BatisServiceImp extends BaseServiceImp<MtRecordPO> implements BatisService {
	@Autowired
	private BatisMapper batisMapper;
	
	protected BaseMapper<MtRecordPO> getMapper(){
		return this.batisMapper;
	}

	@Override
	public int getCount() {
		return batisMapper.getCount();
	}

	@Override
	public List<MtRecordDTO> getList(PageDataDTO pageDataDTO) {
		if (pageDataDTO == null){
			return Collections.emptyList();
		}
		List<MtRecordPO> list = batisMapper.getList(pageDataDTO);
		List<MtRecordDTO> dtoList = new ArrayList<MtRecordDTO>();
		if (list == null || list.size() < 1){
			return Collections.emptyList();
		}
		SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
		for (MtRecordPO mtRecordPO : list){
			MtRecordDTO mtRecordDTO = mtRecordPO.Entity2DTO();
			mtRecordDTO.setAddTime(sdf.format(mtRecordPO.getAddTime()));
			dtoList.add(mtRecordDTO);
		}
		return dtoList;
	}

	@Override
	public int getCountByStatus() {
		return batisMapper.getCountByStatus();
	}

	@Override
	public MtRecordDTO getByOrderSn(String orderSn) {
		if (StringUtils.isBlank(orderSn)){
			return null;
		}
		MtRecordPO mtRecordPO = batisMapper.getByOrderSn(orderSn);
		if (mtRecordPO == null){
			return null;
		}
		return mtRecordPO.Entity2DTO();
	}

	@Override
	public int updateById(MtRecordPO mtRecordPO) {
		return batisMapper.updateById(mtRecordPO);
	}

	@Override
	public int getTotalMoney() {
		return batisMapper.getTotalMoney();
	}

	@Override
	public int insertSelective(MtRecordPO mtRecordPO) {
		return batisMapper.insertSelective(mtRecordPO);
	}
}
