package com.mtgg.utils.voice;

import lombok.extern.slf4j.Slf4j;
import org.json.JSONException;
import sun.audio.AudioPlayer;
import sun.audio.AudioStream;

import javax.servlet.http.HttpServletRequest;
import java.io.*;
import java.net.HttpURLConnection;
import java.net.URL;

/**
 * @Author: MTGG
 * @Date: 15:04 2018/7/19
 * @Describe:
 */
@Slf4j
public class TtsMain {

    //  填写网页上申请的appkey 如 $apiKey="g8eBUMSokVB1BHGmgxxxxxx"
    private final String appKey = "xx";
    // 填写网页上申请的APP SECRET 如 $secretKey="94dc99566550d87f8fa8ece112xxxxx"
    private final String secretKey = "xx";
    // text 的内容为"欢迎使用百度语音合成"的urlencode,utf-8 编码
    // 可以百度搜索"urlencode"
    private final String text = "您有入账哦，请注意查收！";
    // 发音人选择, 0为普通女声，1为普通男生，3为情感合成-度逍遥，4为情感合成-度丫丫，默认为普通女声
    private final int per = 0;
    // 语速，取值0-15，默认为5中语速
    private final int spd = 4;
    // 音调，取值0-15，默认为5中语调
    private final int pit = 5;
    // 音量，取值0-9，默认为5中音量
    private final int vol = 6;
    // 下载的文件格式, 3：mp3(default) 4： pcm-16k 5： pcm-8k 6. wav
    private final int aue = 6;
    public final String url = "http://tsn.baidu.com/text2audio"; // 可以使用https
    private final String cuid = "1234567JAVA";

    public String voiceRun(HttpServletRequest request){
        try {
            TokenHolder holder = new TokenHolder(appKey, secretKey, TokenHolder.ASR_SCOPE);
            holder.refresh();
            String token = holder.getToken();
            // 此处2次urlencode， 确保特殊字符被正确编码
            String params = "tex=" + ConnUtil.urlEncode(ConnUtil.urlEncode(text));
            params += "&per=" + per;
            params += "&spd=" + spd;
            params += "&pit=" + pit;
            params += "&vol=" + vol;
            params += "&cuid=" + cuid;
            params += "&tok=" + token;
            params += "&aue=" + aue;
            params += "&lan=zh&ctp=1";
            log.info("反馈请带上此url，浏览器上可以测试:{}", url + "?" + params); // 反馈请带上此url，浏览器上可以测试
            HttpURLConnection conn = (HttpURLConnection) new URL(url).openConnection();
            conn.setDoInput(true);
            conn.setDoOutput(true);
            conn.setConnectTimeout(5000);
            PrintWriter printWriter = new PrintWriter(conn.getOutputStream());
            printWriter.write(params);
            printWriter.close();
            String contentType = conn.getContentType();
            if (contentType.contains("audio/")) {
                byte[] bytes = ConnUtil.getResponseBytes(conn);
                String format = getFormat(aue);
                // 第二种：获取项目路径
                File directory = new File("");// 参数为空
                String path = request.getSession().getServletContext().getRealPath("/");
                System.out.println(path);
                File file = new File(path + "result." + format); // 打开mp3文件即可播放
                FileOutputStream os = new FileOutputStream(file);
                os.write(bytes);
                os.close();
                log.info("存储路径：{}", file.getAbsolutePath());
//                boolean ret = voiceStart(format);
//                log.info("播放结果：{}", ret);
                return "success";
            } else {
                System.err.println("ERROR: content-type= " + contentType);
                String res = ConnUtil.getResponseString(conn);
                System.err.println(res);
                return null;
            }
        }catch (Exception e){
            return null;
        }
    }

    // 下载的文件格式, 3：mp3(default) 4： pcm-16k 5： pcm-8k 6. wav
    private String getFormat(int aue) {
        String[] formats = {"mp3", "pcm", "pcm", "wav"};
        return formats[aue - 3];
    }

    /**
     * @Author: MTGG
     * @Date: 22:57 2018/7/23
     * @Describe: 播放wav文件
     */
    public static boolean voiceStart(String format) {
        try {
            log.info("播放开始,{}", System.getProperty("user.dir"));
            // 1.wav 文件放在java project 下面 即可播放
            FileInputStream fileau = new FileInputStream(
                    System.getProperty("user.dir") + "\\result." + format);
            AudioStream as = null;
            as = new AudioStream(fileau);
            AudioPlayer.player.start(as);
            return true;
        } catch (IOException e) {
            e.printStackTrace();
            return false;
        }
    }

    public static void main(String[] args) {
//        try {
//            (new TtsMain()).voiceRun();
//        } catch (Exception e) {
//            e.printStackTrace();
//        }
    }

}
